Bullet Collision Detection & Physics Library: btConvexPointCloudShape Class Reference

Bullet Collision Detection & Physics Library

Public Member Functions | Private Attributes | List of all members
btConvexPointCloudShape Class Reference

The btConvexPointCloudShape implements an implicit convex hull of an array of vertices. More...

`#include <btConvexPointCloudShape.h>`

Inheritance diagram for btConvexPointCloudShape:
[legend]
Collaboration diagram for btConvexPointCloudShape:
[legend]

## Public Member Functions
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btConvexPointCloudShape ()
| btConvexPointCloudShape (btVector3 *points, int numPoints, const btVector3 &localScaling, bool computeAabb=true)
void | setPoints (btVector3 *points, int numPoints, bool computeAabb=true, const btVector3 &localScaling=btVector3(1.f, 1.f, 1.f))
btVector3 * | getUnscaledPoints ()
const btVector3 * | getUnscaledPoints () const
int | getNumPoints () const
btVector3 | getScaledPoint (int index) const
virtual btVector3 | localGetSupportingVertex (const btVector3 &vec) const
virtual btVector3 | localGetSupportingVertexWithoutMargin (const btVector3 &vec) const
virtual void | batchedUnitVectorGetSupportingVertexWithoutMargin (const btVector3 *vectors, btVector3 *supportVerticesOut, int numVectors) const
virtual const char * | getName () const
virtual int | getNumVertices () const
virtual int | getNumEdges () const
virtual void | getEdge (int i, btVector3 &pa, btVector3 &pb) const
virtual void | getVertex (int i, btVector3 &vtx) const
virtual int | getNumPlanes () const
virtual void | getPlane (btVector3 &planeNormal, btVector3 &planeSupport, int i) const
virtual bool | isInside (const btVector3 &pt, btScalar tolerance) const
virtual void | setLocalScaling (const btVector3 &scaling)
| in case we receive negative scaling More...
Public Member Functions inherited from btPolyhedralConvexAabbCachingShape
void | getNonvirtualAabb (const btTransform &trans, btVector3 &aabbMin, btVector3 &aabbMax, btScalar margin) const
virtual void | getAabb (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
| getAabb's default implementation is brute force, expected derived classes to implement a fast dedicated version More...
void | recalcLocalAabb ()
Public Member Functions inherited from btPolyhedralConvexShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btPolyhedralConvexShape ()
virtual | ~btPolyhedralConvexShape ()
virtual bool | initializePolyhedralFeatures (int shiftVerticesByMargin=0)
| optional method mainly used to generate multiple contact points by clipping polyhedral features (faces/edges) experimental/work-in-progress More...
const btConvexPolyhedron * | getConvexPolyhedron () const
virtual void | calculateLocalInertia (btScalar mass, btVector3 &inertia) const
Public Member Functions inherited from btConvexInternalShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
virtual | ~btConvexInternalShape ()
const btVector3 & | getImplicitShapeDimensions () const
void | setImplicitShapeDimensions (const btVector3 &dimensions)
| warning: use setImplicitShapeDimensions with care changing a collision shape while the body is in the world is not recommended, it is best to remove the body from the world, then make the change, and re-add it alternatively flush the contact points, see documentation for 'cleanProxyFromPairs' More...
void | setSafeMargin (btScalar minDimension, btScalar defaultMarginMultiplier=0.1f)
void | setSafeMargin (const btVector3 &halfExtents, btScalar defaultMarginMultiplier=0.1f)
virtual void | getAabbSlow (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual const btVector3 & | getLocalScaling () const
const btVector3 & | getLocalScalingNV () const
virtual void | setMargin (btScalar margin)
virtual btScalar | getMargin () const
btScalar | getMarginNV () const
virtual int | getNumPreferredPenetrationDirections () const
virtual void | getPreferredPenetrationDirection (int index, btVector3 &penetrationVector) const
virtual int | calculateSerializeBufferSize () const
virtual const char * | serialize (void *dataBuffer, btSerializer *serializer) const
| fills the dataBuffer and returns the struct name (and 0 on failure) More...
Public Member Functions inherited from btConvexShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btConvexShape ()
| not supported on IBM SDK, until we fix the alignment of btVector3 More...
virtual | ~btConvexShape ()
btVector3 | localGetSupportVertexWithoutMarginNonVirtual (const btVector3 &vec) const
btVector3 | localGetSupportVertexNonVirtual (const btVector3 &vec) const
btScalar | getMarginNonVirtual () const
void | getAabbNonVirtual (const btTransform &t, btVector3 &aabbMin, btVector3 &aabbMax) const
virtual void | project (const btTransform &trans, const btVector3 &dir, btScalar &minProj, btScalar &maxProj, btVector3 &witnesPtMin, btVector3 &witnesPtMax) const
Public Member Functions inherited from btCollisionShape
| BT_DECLARE_ALIGNED_ALLOCATOR ()
| btCollisionShape ()
virtual | ~btCollisionShape ()
virtual void | getBoundingSphere (btVector3 &center, btScalar &radius) const
virtual btScalar | getAngularMotionDisc () const
| getAngularMotionDisc returns the maximum radius needed for Conservative Advancement to handle time-of-impact with rotations. More...
virtual btScalar | getContactBreakingThreshold (btScalar defaultContactThresholdFactor) const
void | calculateTemporalAabb (const btTransform &curTrans, const btVector3 &linvel, const btVector3 &angvel, btScalar timeStep, btVector3 &temporalAabbMin, btVector3 &temporalAabbMax) const
| calculateTemporalAabb calculates the enclosing aabb for the moving object over interval [0..timeStep) result is conservative More...
bool | isPolyhedral () const
bool | isConvex2d () const
bool | isConvex () const
bool | isNonMoving () const
bool | isConcave () const
bool | isCompound () const
bool | isSoftBody () const
bool | isInfinite () const
| isInfinite is used to catch simulation error (aabb check) More...
int | getShapeType () const
virtual btVector3 | getAnisotropicRollingFrictionDirection () const
| the getAnisotropicRollingFrictionDirection can be used in combination with setAnisotropicFriction See Bullet/Demos/RollingFrictionDemo for an example More...
void | setUserPointer (void *userPtr)
| optional user data pointer More...
void * | getUserPointer () const
void | setUserIndex (int index)
int | getUserIndex () const
virtual void | serializeSingleShape (btSerializer *serializer) const

## Private Attributes
btVector3 * | m_unscaledPoints
int | m_numPoints

## Additional Inherited Members
Protected Member Functions inherited from btPolyhedralConvexAabbCachingShape
void | setCachedLocalAabb (const btVector3 &aabbMin, const btVector3 &aabbMax)
void | getCachedLocalAabb (btVector3 &aabbMin, btVector3 &aabbMax) const
| btPolyhedralConvexAabbCachingShape ()
Protected Member Functions inherited from btConvexInternalShape
| btConvexInternalShape ()
Protected Attributes inherited from btPolyhedralConvexShape
btConvexPolyhedron * | m_polyhedron
Protected Attributes inherited from btConvexInternalShape
btVector3 | m_localScaling
btVector3 | m_implicitShapeDimensions
btScalar | m_collisionMargin
btScalar | m_padding
Protected Attributes inherited from btCollisionShape
int | m_shapeType
void * | m_userPointer
int | m_userIndex

## Detailed Description

The btConvexPointCloudShape implements an implicit convex hull of an array of vertices.

Definition at line 24 of file btConvexPointCloudShape.h.

## Constructor & Destructor Documentation

## ◆ btConvexPointCloudShape() [1/2]

btConvexPointCloudShape::btConvexPointCloudShape | ( |  | ) |
| inline

Definition at line 32 of file btConvexPointCloudShape.h.

## ◆ btConvexPointCloudShape() [2/2]

btConvexPointCloudShape::btConvexPointCloudShape | ( | btVector3 * | points,
|  | int | numPoints,
|  | const btVector3 & | localScaling,
|  | bool | computeAabb = `true`
| ) |  |
| inline

Definition at line 40 of file btConvexPointCloudShape.h.

## Member Function Documentation

## ◆ batchedUnitVectorGetSupportingVertexWithoutMargin()

void btConvexPointCloudShape::batchedUnitVectorGetSupportingVertexWithoutMargin | ( | const btVector3 * | vectors,
|  | btVector3 * | supportVerticesOut,
|  | int | numVectors
| ) |  | const
| virtual

Reimplemented from btPolyhedralConvexShape.

Definition at line 55 of file btConvexPointCloudShape.cpp.

## ◆ BT_DECLARE_ALIGNED_ALLOCATOR()

btConvexPointCloudShape::BT_DECLARE_ALIGNED_ALLOCATOR | ( |  | ) |

## ◆ getEdge()

void btConvexPointCloudShape::getEdge | ( | int | i,
|  | btVector3 & | pa,
|  | btVector3 & | pb
| ) |  | const
| virtual

Implements btPolyhedralConvexShape.

Definition at line 112 of file btConvexPointCloudShape.cpp.

## ◆ getName()

virtual const char* btConvexPointCloudShape::getName | ( |  | ) | const
| inlinevirtual

Implements btCollisionShape.

Definition at line 89 of file btConvexPointCloudShape.h.

## ◆ getNumEdges()

int btConvexPointCloudShape::getNumEdges | ( |  | ) | const
| virtual

Implements btPolyhedralConvexShape.

Definition at line 107 of file btConvexPointCloudShape.cpp.

## ◆ getNumPlanes()

int btConvexPointCloudShape::getNumPlanes | ( |  | ) | const
| virtual

Implements btPolyhedralConvexShape.

Definition at line 122 of file btConvexPointCloudShape.cpp.

## ◆ getNumPoints()

int btConvexPointCloudShape::getNumPoints | ( |  | ) | const
| inline

Definition at line 71 of file btConvexPointCloudShape.h.

## ◆ getNumVertices()

int btConvexPointCloudShape::getNumVertices | ( |  | ) | const
| virtual

Implements btPolyhedralConvexShape.

Definition at line 102 of file btConvexPointCloudShape.cpp.

## ◆ getPlane()

void btConvexPointCloudShape::getPlane | ( | btVector3 & | planeNormal,
|  | btVector3 & | planeSupport,
|  | int | i
| ) |  | const
| virtual

Implements btPolyhedralConvexShape.

Definition at line 127 of file btConvexPointCloudShape.cpp.

## ◆ getScaledPoint()

btVector3 btConvexPointCloudShape::getScaledPoint | ( | int | index | ) | const
| inline

Definition at line 76 of file btConvexPointCloudShape.h.

## ◆ getUnscaledPoints() [1/2]

btVector3* btConvexPointCloudShape::getUnscaledPoints | ( |  | ) |
| inline

Definition at line 61 of file btConvexPointCloudShape.h.

## ◆ getUnscaledPoints() [2/2]

const btVector3* btConvexPointCloudShape::getUnscaledPoints | ( |  | ) | const
| inline

Definition at line 66 of file btConvexPointCloudShape.h.

## ◆ getVertex()

void btConvexPointCloudShape::getVertex | ( | int | i,
|  | btVector3 & | vtx
| ) |  | const
| virtual

Implements btPolyhedralConvexShape.

Definition at line 117 of file btConvexPointCloudShape.cpp.

## ◆ isInside()

bool btConvexPointCloudShape::isInside | ( | const btVector3 & | pt,
|  | btScalar | tolerance
| ) |  | const
| virtual

Implements btPolyhedralConvexShape.

Definition at line 134 of file btConvexPointCloudShape.cpp.

## ◆ localGetSupportingVertex()

btVector3 btConvexPointCloudShape::localGetSupportingVertex | ( | const btVector3 & | vec | ) | const
| virtual

Reimplemented from btConvexInternalShape.

Definition at line 75 of file btConvexPointCloudShape.cpp.

## ◆ localGetSupportingVertexWithoutMargin()

btVector3 btConvexPointCloudShape::localGetSupportingVertexWithoutMargin | ( | const btVector3 & | vec | ) | const
| virtual

Reimplemented from btPolyhedralConvexShape.

Definition at line 28 of file btConvexPointCloudShape.cpp.

## ◆ setLocalScaling()

void btConvexPointCloudShape::setLocalScaling | ( | const btVector3 & | scaling | ) |
| virtual

in case we receive negative scaling

Reimplemented from btPolyhedralConvexAabbCachingShape.

Definition at line 21 of file btConvexPointCloudShape.cpp.

## ◆ setPoints()

void btConvexPointCloudShape::setPoints | ( | btVector3 * | points,
|  | int | numPoints,
|  | bool | computeAabb = `true`,
|  | const btVector3 & | localScaling = `btVector3(1.f,1.f,1.f)`
| ) |  |
| inline

Definition at line 51 of file btConvexPointCloudShape.h.

## Member Data Documentation

## ◆ m_numPoints

int btConvexPointCloudShape::m_numPoints
| private

Definition at line 27 of file btConvexPointCloudShape.h.

## ◆ m_unscaledPoints

btVector3* btConvexPointCloudShape::m_unscaledPoints
| private

Definition at line 26 of file btConvexPointCloudShape.h.

The documentation for this class was generated from the following files:

- btConvexPointCloudShape.h
- btConvexPointCloudShape.cpp